/* Corsair - Qtopia RSS/Podcast Aggregator
 *
 * Copyright (C) 2005 Joe Rumsey
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */

#ifndef OPMLPARSER_H__
#define OPMLPARSER_H__

class OPMLParser : public QXmlDefaultHandler
{
private:
	FeedList *m_feeds;

public:
	OPMLParser(FeedList *feeds) {
		m_feeds = feeds;
	}

	bool startDocument() {
		LOG(3, "startDocument\n");
		return true;
	}
	bool startElement(const QString &namespaceURI,
					  const QString &localName,
					  const QString &name,
					  const QXmlAttributes &attr)
	{    
		LOG(3, "startElement: %s\n", (const char *)name);
		int i;
		for(i = 0; i < attr.length(); i++) {
			LOG(3, "  %s=%s\n", (const char *)attr.qName(i), (const char *)attr.value(i));
		}
		
		if(name == "outline") {
			m_feeds->AddFeed(attr);
		}
		
		return true;
	}

	bool endElement(const QString &namespaceURI,
					const QString &localName,
					const QString &name) 
	{
		LOG(3, "endElement %s\n", (const char *)name);
		return true;
	}

	bool warning(const QXmlParseException &e) {
		LOG(1, "warning\n");
		return true;
	}

	bool error(const QXmlParseException &e) {
		LOG(1, "error\n");
		return true;
	}

	bool fatalError(const QXmlParseException &e) {
		LOG(1, "fatal error: %s\n", (const char *)e.message());
		return true;
	}

};

#endif
